" AutoAlign.vim: a ftplugin for vim
" Author:	Charles E. Campbell, Jr.  <NdrOchip@ScampbellPfamily.AbizM>-NOSPAM
" Date:		Jul 02, 2004
" Version:	4
" History:
"   4 : * see |i_ctrl-g_u| -- breaks undo sequence at every align
"       * ve=all caused problems when backspacing over == - fixed!
"   3 : * autoalign not taken if a no-pattern line is
"         in-between the keepalign line and the current line
"   2 : * b:autoalign==0: turns autoalign off
"         b:autoalign==1: turns autoalign back on
"       * 'a now used during autoalign, and AlignMap's \t=
"         If user changes 'a, then AutoAlign recognizes that
"         it is not to keep aligning
"       * The AA command can be used to toggle AutoAlign
"   1 : The Epoch
if exists("b:did_vim_autoalign")
 finish
endif
let b:did_vim_autoalign = 4

" ---------------------------------------------------------------------
" Public Interface: AA toggles AutoAlign {{{1
com! -nargs=0 AA if exists("b:autoalign")|let b:autoalign= !b:autoalign|else|let b:autoalign= 0|endif|echo "AutoAlign is ".(b:autoalign? "on" : "off")

" ---------------------------------------------------------------------

" overloading '=' to keep things lined up {{{1
ino <silent> = =<c-o>:let b:autoalign_vekeep=&ve<bar>set ve=<cr><c-o>:silent call <sid>KeepVIMAligned()<cr><c-o>:let &ve=b:autoalign_vekeep<cr>

" KeepAligned: attempts to keep let statements aligned on their '=' signs
fun! s:KeepVIMAligned()
  if exists("b:autoalign") && b:autoalign == 0
   return
  endif
  set lz

  if getline(".") =~ '^\s*let\>.*='
   let curposn   = SaveWinPosn()
   let curline   = line(".")
   let nopatline = search('^[^=]\+$','bW')
   call RestoreWinPosn(curposn)
   if exists("b:keepvimaligned") && line("'a") == b:keepvimaligned && b:keepvimaligned < curline && nopatline < line("'a")
   	exe "norm! i\<c-g>u\<esc>"
   	norm \t=$
   else
   	let b:keepvimaligned= line(".")
	ka
   endif
  elseif exists("b:keepvimaligned")
   unlet b:keepvimaligned
  endif

  set nolz
endfun

" ---------------------------------------------------------------------
" vim: ts=4 fdm=marker
